#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <va/va.h>
#include <va/va_x11.h>
#include <sys/time.h>
#include "wintypedefs.h"
#include "m3Api.h"
#include "m3Ext.h"
#ifdef OPENCL
#include <CL/opencl.h>
#endif

#define CHECK_VASTATUS(va_status,func,todo) \
if (va_status != VA_STATUS_SUCCESS) { \
    fprintf(stderr,"%s:%s (%d) failed %d,exit\n", __func__, func, __LINE__, va_status); \
    todo; \
}

inline DWORD getcurms()
{
	struct timeval now;
	gettimeofday(&now, NULL);
	return (now.tv_sec * 1000 + now.tv_usec / 1000);
}

//this struct was copied from xiViewer
typedef struct _SETUP {
	UINT		uiExposure;		// Exposure time
	UINT		uiMode;			// Camera mode number
	float		fGain;
	DWORD		zoom;

	UINT	dummy;			// border between setup and dynamic data

	BOOL		bDrawImage;	
	char		szMode[32][256];// Human readable modes names
	MMGETFRAMEEX gf;
	MMGETFRAMEEX sgf;
	int			nGetFrame;
	BOOL		bRun;
	DWORD		dwHWN2;
	BOOL		bWasRunning;
	DWORD		dwSerial;
	BOOL		bHaveData;
	DWORD		dwROIx0;
	DWORD		dwROIy0;
	DWORD		dwROIcx;
	DWORD		dwROIcy;
	DWORD		dwNframes;
	DWORD		dwPframes;
	DWORD		dwLframes;
	DWORD		dwTime;
	DWORD		dwCx;
	DWORD		dwCy;
	DWORD		x0;
	DWORD		y0;
	DWORD		cx;
	DWORD		cy;
	DWORD		px;
	DWORD		py;
	DWORD		pv;
	double		fFPS;			// Frames per second 
	double		fFPS_sum;		// Frames per second average
	double		fTPF;			// Time per frame
	DWORD		pcn,pcn0;
	BOOL		bSaveImage;

	unsigned int putsurface_time, frame_num, m_roi_x0, m_roi_y0, m_roi_cx, m_roi_cy;
	BOOL		show;
	BOOL		color;
	MMGETBITMAP	sbmp;
	MMGETBITMAP	bmp;
	BOOL		bTakeWB;
	double		Kr, Kg, Kb;		// white balance koef. RGB
	pthread_t videoThread;
#ifdef OPENCL
	cl_context context;
	cl_command_queue commands;
	cl_kernel rgb2y;
	cl_kernel rgb2uv;
	cl_kernel rgb2u;
	cl_kernel rgb2v;
#endif
} SETUP, *LPSETUP;

void setT0(void);
double getT(void);

void* acquisition(void* args);
int drawImage(VADisplay va_dpy, VASurfaceID surface_id, VAImageFormat *image_format, int surface_width, int surface_height,
		Window win, int win_width, int win_height);
void setupCam();

extern LPSETUP lps;
extern Display *x11_display;
extern HANDLE hMV;
