// xiSample.cpp : program that captures 10 images and finish
//

#include "stdafx.h"

#ifdef __APPLE__
#include <m3api/xiApi.h>
#include <m3api/xiExt.h>
#else
#include "xiApi.h"
#include "xiExt.h"
#endif

#define HandleResult(res,place) if (res!=XI_OK) {printf("Error after %s (%d)\n",place,res);goto finish;}

int _tmain(int argc, _TCHAR* argv[])
{
	// image buffer
	XI_IMG image;
	image.size = sizeof(XI_IMG);
	image.bp = NULL;
	image.bp_size = 0;

	// Sample for XIMEA API V2.10
	HANDLE xiH = NULL;
	XI_RETURN stat = XI_OK;

	// Get number of camera devices
	DWORD dwNumberOfDevices = 0;
	stat = xiGetNumberDevices(&dwNumberOfDevices);
	HandleResult(stat,"xiGetNumberDevices (no camera found)");
	
	if (!dwNumberOfDevices)
	{
		printf("No camera found\n");
		goto finish;
	}
	
	// Retrieving a handle to the camera device 
	stat = xiOpenDevice(0, &xiH);
	HandleResult(stat,"xiOpenDevice");
	
	// Setting "exposure" parameter (10ms=10000us)
	stat = xiSetParamInt(xiH, XI_PRM_EXPOSURE, 10000);
	HandleResult(stat,"xiSetParam (exposure set)");
	
	stat = xiStartAcquisition(xiH);
	HandleResult(stat,"xiStartAcquisition");
	
	#define EXPECTED_IMAGES 10
	for (int images=0;images < EXPECTED_IMAGES;images++)
	{
		// getting image from camera
		stat = xiGetImage(xiH, 5000, &image);
		HandleResult(stat,"xiGetImage");
		printf("Image %d (%dx%d) received from camera\n", images, (int)image.width, (int)image.height);
	}

finish:
	// Close device
	if (xiH)
		xiCloseDevice(xiH);
	printf("Done\n");
#ifdef WIN32
	Sleep(2000);
#endif
	return 0;
}

